// Code generated by sqlc. DO NOT EDIT.
// versions:
//   sqlc v1.26.0
// source: list_delegated_service_publications_count.sql

package queries

import (
	"context"
)

const listDelegatedServicePublicationsCount = `-- name: ListDelegatedServicePublicationsCount :one

SELECT
    count(*) as total_count
FROM (
    SELECT service_peer_id, service_name, content_hash, hash, directory_peer_id, delegator_peer_id
    FROM contracts.grants_delegated_service_publication
    WHERE delegator_peer_id = $1::text
) AS p
JOIN contracts.contracts_with_state AS c ON c.hash = p.content_hash
    WHERE
    CASE
        when cardinality($2::text[]) = 0 THEN
            content_hash IN (SELECT hash AS content_hash FROM contracts.contracts_with_state)
        else
            content_hash IN (SELECT hash AS content_hash FROM contracts.contracts_with_state where contracts_with_state.state = ANY ($2::text[]))
        end
`

type ListDelegatedServicePublicationsCountParams struct {
	SelfPeerID     string
	ContractStates []string
}

// Copyright © VNG Realisatie 2024
// Licensed under the EUPL
func (q *Queries) ListDelegatedServicePublicationsCount(ctx context.Context, arg *ListDelegatedServicePublicationsCountParams) (int64, error) {
	row := q.db.QueryRow(ctx, listDelegatedServicePublicationsCount, arg.SelfPeerID, arg.ContractStates)
	var total_count int64
	err := row.Scan(&total_count)
	return total_count, err
}
